﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
           

            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
            {
                
                string[] allfiles = Directory.GetFiles(folderBrowserDialog1.SelectedPath, "*.mp4", SearchOption.AllDirectories);

            

                foreach (var file in allfiles)
                {
              
                    FileInfo info = new FileInfo(file);
                    listBox1.Items.Add(info.FullName);

                }
            }  


     
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int iOrginalWidth=0; 
            int iOrginalHeight=0; 

            for (int i = 0; i < listBox1.Items.Count; i++)
            {
                string strMediaFile =listBox1.Items[i].ToString();

                if(i==0)
                {
                    iOrginalWidth= axTimelineControl1.GetMediaWidth(strMediaFile);
                    iOrginalHeight= axTimelineControl1.GetMediaHeight(strMediaFile);
                }

                float iDur = axTimelineControl1.GetMediaDuration(strMediaFile);
                axTimelineControl1.AddVideoClip(1, strMediaFile, 0, (int)iDur, 0);

                int iAudioStreamCount = axTimelineControl1.GetMediaAudioStreamCount(strMediaFile);
                
                if(iAudioStreamCount!=0)
                    axTimelineControl1.AddAudioClip(5, strMediaFile, 0, (int)iDur, 0, 1);
              

            }
           
            axTimelineControl1.SetVideoTrackResolution(iOrginalWidth, iOrginalHeight);
            axTimelineControl1.SetVideoTrackFrameRate(25);
            axTimelineControl1.OutputType = 2;

         
            axTimelineControl1.MP4AspectRatio =0;
            axTimelineControl1.MP4AudioBitrate =96000;
            axTimelineControl1.MP4AudioChannels = 2;
            axTimelineControl1.MP4AudioSampleRate = 44100;
            axTimelineControl1.MP4Framerate= 25;
            axTimelineControl1.MP4H264Preset = 0;
            axTimelineControl1.MP4Height = 2160;
            axTimelineControl1.MP4Width = 3840;
            axTimelineControl1.MP4VideoBitrate = 5000000;
            
            int iresult =axTimelineControl1.Save("c:\\temp\\output.mp4");


            if (iresult != 1)
            {
                MessageBox.Show("Save Failed");
            }
            

        }

        private void axTimelineControl1_OnConvertCompleted(object sender, EventArgs e)
        {
            MessageBox.Show("Convert Completed");
        }

        private void axTimelineControl1_OnConvertProgress(object sender, AxTimelineAxLib._ITimelineControlEvents_OnConvertProgressEvent e)
        {
            progressBar1.Value = e.progress;
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
    }
}
